/**@file
 * This file is part of the ARM BSP for the Test Environment.
 *
 * @copyright 2018-2024 N7 Space Sp. z o.o.
 *
 * Test Environment was developed under a programme of,
 * and funded by, the European Space Agency (the "ESA").
 *
 *
 * Licensed under the ESA Public License (ESA-PL) Permissive (Type 3),
 * Version 2.4 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     https://essr.esa.int/license/list
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef N7S_BSP_MCAN_MCANREGISTERS_H
#define N7S_BSP_MCAN_MCANREGISTERS_H

#include <stdint.h>

typedef struct {
	uint32_t crel; ///< 0x00 Core Release Register
	uint32_t endn; ///< 0x04 Endian Register
	uint32_t cust; ///< 0x08 Customer Register
	uint32_t dbtp; ///< 0x0C Data Bit Timing and Prescaler Register
	uint32_t test; ///< 0x10 Test Register
	uint32_t rwd; ///< 0x14 RAM Watchdog Register
	uint32_t cccr; ///< 0x18 CC Control Register
	uint32_t nbtp; ///< 0x1C Nominal Bit Timing and Prescaler Register
	uint32_t tscc; ///< 0x20 Timestamp Counter Configuration Register
	uint32_t tscv; ///< 0x24 Timestamp Counter Value Register
	uint32_t tocc; ///< 0x28 Timeout Counter Configuration Register
	uint32_t tocv; ///< 0x2C Timeout Counter Value Register
	uint32_t reserved1[4]; ///< 0x30 - 0x3C Reserved
	uint32_t ecr; ///< 0x40 Error Counter Register
	uint32_t psr; ///< 0x44 Protocol Status Register
	uint32_t tdcr; ///< 0x48 Transmit Delay Compensation Register
	uint32_t reserved2; ///< 0x4C Reserved
	uint32_t ir; ///< 0x50 Interrupt Register
	uint32_t ie; ///< 0x54 Interrupt Enable Register
	uint32_t ils; ///< 0x58 Interrupt Line Select Register
	uint32_t ile; ///< 0x5C Interrupt Line Enable Register
	uint32_t reserved3[8]; ///< 0x60 - 0x7C Reserved
	uint32_t gfc; ///< 0x80 Global Filter Configuration Register
	uint32_t sidfc; ///< 0x84 Standard ID Filter Configuration Register
	uint32_t xidfc; ///< 0x88 Extended ID Filter Configuration Register
	uint32_t reserved4; ///< 0x8C Reserved
	uint32_t xidam; ///< 0x90 Extended ID AND Mask Register
	uint32_t hpms; ///< 0x94 High Priority Message Status Register
	uint32_t ndat1; ///< 0x98 New Data 1 Register
	uint32_t ndat2; ///< 0x9C New Data 2 Register
	uint32_t rxf0c; ///< 0xA0 Receive FIFO 0 Configuration Register
	uint32_t rxf0s; ///< 0xA4 Receive FIFO 0 Status Register
	uint32_t rxf0a; ///< 0xA8 Receive FIFO 0 Acknowledge Register
	uint32_t rxbc; ///< 0xAC Receive Rx Buffer Configuration Register
	uint32_t rxf1c; ///< 0xB0 Receive FIFO 1 Configuration Register
	uint32_t rxf1s; ///< 0xB4 Receive FIFO 1 Status Register
	uint32_t rxf1a; ///< 0xB8 Receive FIFO 1 Acknowledge Register
	uint32_t rxesc; ///< 0xBC Receive Element Size Configuration Register
	uint32_t txbc; ///< 0xC0 Transmit Buffer Configuration Register
	uint32_t txfqs; ///< 0xC4 Transmit FIFO/Queue Status Register
	uint32_t txesc; ///< 0xC8 Transmit Buffer Element Size Configuration Register
	uint32_t txbrp; ///< 0xCC Transmit Buffer Request Pending Register
	uint32_t txbar; ///< 0xD0 Transmit Buffer Add Request Register
	uint32_t txbcr; ///< 0xD4 Transmit Buffer Cancellation Request Register
	uint32_t txbto; ///< 0xD8 Transmit Buffer Transmission Occurred Register
	uint32_t txbcf; ///< 0xDC Transmit Buffer Cancellation Finished Register
	uint32_t txbtie; ///< 0xE0 Transmit Buffer Transmission Interrupt Enable Register
	/// \brief 0xE4 Transmit Buffer Cancellation Finished Interrupt Enable Register
	uint32_t txbcie;
	uint32_t reserved5[2]; ///< 0xE8 - 0xEC Reserved
	uint32_t txefc; ///< 0xF0 Transmit Event FIFO Configuration Register
	uint32_t txefs; ///< 0xF4 Transmit Event FIFO Status Register
	uint32_t txefa; ///< 0xF8 Transmit Event FIFO Acknowledge Register
	uint32_t reserved6; ///< 0xFC Reserved
} Mcan_BaseRegisters;

typedef struct {
	volatile Mcan_BaseRegisters *base;
	volatile uint32_t *canDmaBase;
} Mcan_Registers;

#define MCAN_CHIPCFG_CANXDMABA_MASK 0xFFFF0000u
#define MCAN_CHIPCFG_CANXDMABA_OFFSET 16u

#if defined(N7S_TARGET_SAMV71Q21)
#define MCAN0_CHIPCFG_CAN_DMA_ADDRESS_BASE 0x40088110u
#define MCAN1_CHIPCFG_CAN_DMA_ADDRESS_BASE 0x40088114u

#define MCAN0_ADDRESS_BASE 0x40030000u
#define MCAN1_ADDRESS_BASE 0x40034000u

#elif defined(N7S_TARGET_SAMRH71F20)

#define MCAN0_CHIPCFG_CAN_DMA_ADDRESS_BASE 0x400A00A0u
#define MCAN1_CHIPCFG_CAN_DMA_ADDRESS_BASE 0x400A00A4u

#define MCAN0_ADDRESS_BASE 0x40058000u
#define MCAN1_ADDRESS_BASE 0x4005C000u

#elif defined(N7S_TARGET_SAMRH707F18)

#define MCAN0_CHIPCFG_CAN_DMA_ADDRESS_BASE 0x400A00A0u
#define MCAN1_CHIPCFG_CAN_DMA_ADDRESS_BASE 0x400A00A4u

#define MCAN0_ADDRESS_BASE 0x40058000u
#define MCAN1_ADDRESS_BASE 0x4005C000u

#endif

#define MCAN_CREL_DAY_MASK 0x000000FFu
#define MCAN_CREL_DAY_OFFSET 0u
#define MCAN_CREL_MON_MASK 0x0000FF00u
#define MCAN_CREL_MON_OFFSET 8u
#define MCAN_CREL_YEAR_MASK 0x000F0000u
#define MCAN_CREL_YEAR_OFFSET 16u
#define MCAN_CREL_SUBSTEP_MASK 0x00F00000u
#define MCAN_CREL_SUBSTEP_OFFSET 20u
#define MCAN_CREL_STEP_MASK 0x0F000000u
#define MCAN_CREL_STEP_OFFSET 24u
#define MCAN_CREL_REL_MASK 0xF0000000u
#define MCAN_CREL_REL_OFFSET 28u

#define MCAN_ENDN_ETV_MASK 0xFFFFFFFFu
#define MCAN_ENDN_ETV_OFFSET 0u

#define MCAN_CUST_CSV_MASK 0xFFFFFFFFu
#define MCAN_CUST_CSV_OFFSET 0u

#define MCAN_DBTP_DSJW_MASK 0x00000007u
#define MCAN_DBTP_DSJW_OFFSET 0u
#define MCAN_DBTP_DTSEG2_MASK 0x000000F0u
#define MCAN_DBTP_DTSEG2_OFFSET 4u
#define MCAN_DBTP_DTSEG1_MASK 0x00000F00u
#define MCAN_DBTP_DTSEG1_OFFSET 8u
#define MCAN_DBTP_DBRP_MASK 0x000F0000u
#define MCAN_DBTP_DBRP_OFFSET 16u
#define MCAN_DBTP_TDC_MASK 0x00800000u
#define MCAN_DBTP_TDC_OFFSET 23u

#define MCAN_TEST_LBCK_MASK 0x00000010u
#define MCAN_TEST_LBCK_OFFSET 4u
#define MCAN_TEST_TX_MASK 0x00000060u
#define MCAN_TEST_TX_OFFSET 5u
#define MCAN_TEST_RX_MASK 0x00000080u
#define MCAN_TEST_RX_OFFSET 7u

#define MCAN_RWD_WDC_MASK 0x000000FFu
#define MCAN_RWD_WDC_OFFSET 0u
#define MCAN_RWD_WDV_MASK 0x0000FF00u
#define MCAN_RWD_WDV_OFFSET 8u

#define MCAN_CCCR_INIT_MASK 0x00000001u
#define MCAN_CCCR_INIT_OFFSET 0u
#define MCAN_CCCR_CCE_MASK 0x00000002u
#define MCAN_CCCR_CCE_OFFSET 1u
#define MCAN_CCCR_ASM_MASK 0x00000004u
#define MCAN_CCCR_ASM_OFFSET 2u
#define MCAN_CCCR_CSA_MASK 0x00000008u
#define MCAN_CCCR_CSA_OFFSET 3u
#define MCAN_CCCR_CSR_MASK 0x00000010u
#define MCAN_CCCR_CSR_OFFSET 4u
#define MCAN_CCCR_MON_MASK 0x00000020u
#define MCAN_CCCR_MON_OFFSET 5u
#define MCAN_CCCR_DAR_MASK 0x00000040u
#define MCAN_CCCR_DAR_OFFSET 6u
#define MCAN_CCCR_TEST_MASK 0x00000080u
#define MCAN_CCCR_TEST_OFFSET 7u
#define MCAN_CCCR_FDOE_MASK 0x00000100u
#define MCAN_CCCR_FDOE_OFFSET 8u
#define MCAN_CCCR_BRSE_MASK 0x00000200u
#define MCAN_CCCR_BRSE_OFFSET 9u
#define MCAN_CCCR_PXHD_MASK 0x00001000u
#define MCAN_CCCR_PXHD_OFFSET 12u
#define MCAN_CCCR_EFBI_MASK 0x00002000u
#define MCAN_CCCR_EFBI_OFFSET 13u
#define MCAN_CCCR_TXP_MASK 0x00004000u
#define MCAN_CCCR_TXP_OFFSET 14u
#define MCAN_CCCR_NISO_MASK 0x00008000u
#define MCAN_CCCR_NISO_OFFSET 15u

#define MCAN_NBTP_NTSEG2_MASK 0x0000007Fu
#define MCAN_NBTP_NTSEG2_OFFSET 0u
#define MCAN_NBTP_NTSEG1_MASK 0x0000FF00u
#define MCAN_NBTP_NTSEG1_OFFSET 8u
#define MCAN_NBTP_NBRP_MASK 0x01FF0000u
#define MCAN_NBTP_NBRP_OFFSET 16u
#define MCAN_NBTP_NSJW_MASK 0xFE000000u
#define MCAN_NBTP_NSJW_OFFSET 25u

#define MCAN_TSCC_TSS_MASK 0x00000003u
#define MCAN_TSCC_TSS_OFFSET 0u
#define MCAN_TSCC_TCP_MASK 0x000F0000u
#define MCAN_TSCC_TCP_OFFSET 16u

#define MCAN_TSCV_TSC_MASK 0x0000FFFFu
#define MCAN_TSCV_TSC_OFFSET 0u

#define MCAN_TOCC_ETOC_MASK 0x00000001u
#define MCAN_TOCC_ETOC_OFFSET 0u
#define MCAN_TOCC_TOS_MASK 0x00000006u
#define MCAN_TOCC_TOS_OFFSET 1u
#define MCAN_TOCC_TOP_MASK 0xFFFF0000u
#define MCAN_TOCC_TOP_OFFSET 16u

#define MCAN_TOCV_TOC_MASK 0x0000FFFFu
#define MCAN_TOCV_TOC_OFFSET 0u

#define MCAN_ECR_TEC_MASK 0x000000FFu
#define MCAN_ECR_TEC_OFFSET 0u
#define MCAN_ECR_REC_MASK 0x00007F00u
#define MCAN_ECR_REC_OFFSET 8u
#define MCAN_ECR_RP_MASK 0x00008000u
#define MCAN_ECR_RP_OFFSET 15u
#define MCAN_ECR_CEL_MASK 0x00FF0000u
#define MCAN_ECR_CEL_OFFSET 16u

#define MCAN_PSR_LEC_MASK 0x00000007u
#define MCAN_PSR_LEC_OFFSET 0u
#define MCAN_PSR_ACT_MASK 0x00000018u
#define MCAN_PSR_ACT_OFFSET 3u
#define MCAN_PSR_EP_MASK 0x00000020u
#define MCAN_PSR_EP_OFFSET 5u
#define MCAN_PSR_EW_MASK 0x00000040u
#define MCAN_PSR_EW_OFFSET 6u
#define MCAN_PSR_BO_MASK 0x00000080u
#define MCAN_PSR_BO_OFFSET 7u
#define MCAN_PSR_DLEC_MASK 0x00000700u
#define MCAN_PSR_DLEC_OFFSET 8u
#define MCAN_PSR_RESI_MASK 0x00000800u
#define MCAN_PSR_RESI_OFFSET 11u
#define MCAN_PSR_RBRS_MASK 0x00001000u
#define MCAN_PSR_RBRS_OFFSET 12u
#define MCAN_PSR_RFDF_MASK 0x00002000u
#define MCAN_PSR_RFDF_OFFSET 13u
#define MCAN_PSR_PXE_MASK 0x00004000u
#define MCAN_PSR_PXE_OFFSET 14u
#define MCAN_PSR_TDCV_MASK 0x007F0000u
#define MCAN_PSR_TDCV_OFFSET 16u

#define MCAN_TDCR_TDCF_MASK 0x0000007Fu
#define MCAN_TDCR_TDCF_OFFSET 0u
#define MCAN_TDCR_TDCO_MASK 0x00007F00u
#define MCAN_TDCR_TDCO_OFFSET 8u

#define MCAN_IR_RF0N_MASK 0x00000001u
#define MCAN_IR_RF0N_OFFSET 0u
#define MCAN_IR_RF0W_MASK 0x00000002u
#define MCAN_IR_RF0W_OFFSET 1u
#define MCAN_IR_RF0F_MASK 0x00000004u
#define MCAN_IR_RF0F_OFFSET 2u
#define MCAN_IR_RF0L_MASK 0x00000008u
#define MCAN_IR_RF0L_OFFSET 3u
#define MCAN_IR_RF1N_MASK 0x00000010u
#define MCAN_IR_RF1N_OFFSET 4u
#define MCAN_IR_RF1W_MASK 0x00000020u
#define MCAN_IR_RF1W_OFFSET 5u
#define MCAN_IR_RF1F_MASK 0x00000040u
#define MCAN_IR_RF1F_OFFSET 6u
#define MCAN_IR_RF1L_MASK 0x00000080u
#define MCAN_IR_RF1L_OFFSET 7u
#define MCAN_IR_HPM_MASK 0x00000100u
#define MCAN_IR_HPM_OFFSET 8u
#define MCAN_IR_TC_MASK 0x00000200u
#define MCAN_IR_TC_OFFSET 9u
#define MCAN_IR_TCF_MASK 0x00000400u
#define MCAN_IR_TCF_OFFSET 10u
#define MCAN_IR_TFE_MASK 0x00000800u
#define MCAN_IR_TFE_OFFSET 11u
#define MCAN_IR_TEFN_MASK 0x00001000u
#define MCAN_IR_TEFN_OFFSET 12u
#define MCAN_IR_TEFW_MASK 0x00002000u
#define MCAN_IR_TEFW_OFFSET 13u
#define MCAN_IR_TEFF_MASK 0x00004000u
#define MCAN_IR_TEFF_OFFSET 14u
#define MCAN_IR_TEFL_MASK 0x00008000u
#define MCAN_IR_TEFL_OFFSET 15u
#define MCAN_IR_TSW_MASK 0x00010000u
#define MCAN_IR_TSW_OFFSET 16u
#define MCAN_IR_MRAF_MASK 0x00020000u
#define MCAN_IR_MRAF_OFFSET 17u
#define MCAN_IR_TOO_MASK 0x00040000u
#define MCAN_IR_TOO_OFFSET 18u
#define MCAN_IR_DRX_MASK 0x00080000u
#define MCAN_IR_DRX_OFFSET 19u
#define MCAN_IR_ELO_MASK 0x00400000u
#define MCAN_IR_ELO_OFFSET 22u
#define MCAN_IR_EP_MASK 0x00800000u
#define MCAN_IR_EP_OFFSET 23u
#define MCAN_IR_EW_MASK 0x01000000u
#define MCAN_IR_EW_OFFSET 24u
#define MCAN_IR_BO_MASK 0x02000000u
#define MCAN_IR_BO_OFFSET 25u
#define MCAN_IR_WDI_MASK 0x04000000u
#define MCAN_IR_WDI_OFFSET 26u
#define MCAN_IR_PEA_MASK 0x08000000u
#define MCAN_IR_PEA_OFFSET 27u
#define MCAN_IR_PED_MASK 0x10000000u
#define MCAN_IR_PED_OFFSET 28u
#define MCAN_IR_ARA_MASK 0x20000000u
#define MCAN_IR_ARA_OFFSET 29u

#define MCAN_IE_RF0NE_MASK 0x00000001u
#define MCAN_IE_RF0NE_OFFSET 0u
#define MCAN_IE_RF0WE_MASK 0x00000002u
#define MCAN_IE_RF0WE_OFFSET 1u
#define MCAN_IE_RF0FE_MASK 0x00000004u
#define MCAN_IE_RF0FE_OFFSET 2u
#define MCAN_IE_RF0LE_MASK 0x00000008u
#define MCAN_IE_RF0LE_OFFSET 3u
#define MCAN_IE_RF1NE_MASK 0x00000010u
#define MCAN_IE_RF1NE_OFFSET 4u
#define MCAN_IE_RF1WE_MASK 0x00000020u
#define MCAN_IE_RF1WE_OFFSET 5u
#define MCAN_IE_RF1FE_MASK 0x00000040u
#define MCAN_IE_RF1FE_OFFSET 6u
#define MCAN_IE_RF1LE_MASK 0x00000080u
#define MCAN_IE_RF1LE_OFFSET 7u
#define MCAN_IE_HPME_MASK 0x00000100u
#define MCAN_IE_HPME_OFFSET 8u
#define MCAN_IE_TCE_MASK 0x00000200u
#define MCAN_IE_TCE_OFFSET 9u
#define MCAN_IE_TCFE_MASK 0x00000400u
#define MCAN_IE_TCFE_OFFSET 10u
#define MCAN_IE_TFEE_MASK 0x00000800u
#define MCAN_IE_TFEE_OFFSET 11u
#define MCAN_IE_TEFNE_MASK 0x00001000u
#define MCAN_IE_TEFNE_OFFSET 12u
#define MCAN_IE_TEFWE_MASK 0x00002000u
#define MCAN_IE_TEFWE_OFFSET 13u
#define MCAN_IE_TEFFE_MASK 0x00004000u
#define MCAN_IE_TEFFE_OFFSET 14u
#define MCAN_IE_TEFLE_MASK 0x00008000u
#define MCAN_IE_TEFLE_OFFSET 15u
#define MCAN_IE_TSWE_MASK 0x00010000u
#define MCAN_IE_TSWE_OFFSET 16u
#define MCAN_IE_MRAFE_MASK 0x00020000u
#define MCAN_IE_MRAFE_OFFSET 17u
#define MCAN_IE_TOOE_MASK 0x00040000u
#define MCAN_IE_TOOE_OFFSET 18u
#define MCAN_IE_DRXE_MASK 0x00080000u
#define MCAN_IE_DRXE_OFFSET 19u
#define MCAN_IE_ELOE_MASK 0x00400000u
#define MCAN_IE_ELOE_OFFSET 22u
#define MCAN_IE_EPE_MASK 0x00800000u
#define MCAN_IE_EPE_OFFSET 23u
#define MCAN_IE_EWE_MASK 0x01000000u
#define MCAN_IE_EWE_OFFSET 24u
#define MCAN_IE_BOE_MASK 0x02000000u
#define MCAN_IE_BOE_OFFSET 25u
#define MCAN_IE_WDIE_MASK 0x04000000u
#define MCAN_IE_WDIE_OFFSET 26u
#define MCAN_IE_PEAE_MASK 0x08000000u
#define MCAN_IE_PEAE_OFFSET 27u
#define MCAN_IE_PEDE_MASK 0x10000000u
#define MCAN_IE_PEDE_OFFSET 28u
#define MCAN_IE_ARAE_MASK 0x20000000u
#define MCAN_IE_ARAE_OFFSET 29u

#define MCAN_ILS_RF0NL_MASK 0x00000001u
#define MCAN_ILS_RF0NL_OFFSET 0u
#define MCAN_ILS_RF0WL_MASK 0x00000002u
#define MCAN_ILS_RF0WL_OFFSET 1u
#define MCAN_ILS_RF0FL_MASK 0x00000004u
#define MCAN_ILS_RF0FL_OFFSET 2u
#define MCAN_ILS_RF0LL_MASK 0x00000008u
#define MCAN_ILS_RF0LL_OFFSET 3u
#define MCAN_ILS_RF1NL_MASK 0x00000010u
#define MCAN_ILS_RF1NL_OFFSET 4u
#define MCAN_ILS_RF1WL_MASK 0x00000020u
#define MCAN_ILS_RF1WL_OFFSET 5u
#define MCAN_ILS_RF1FL_MASK 0x00000040u
#define MCAN_ILS_RF1FL_OFFSET 6u
#define MCAN_ILS_RF1LL_MASK 0x00000080u
#define MCAN_ILS_RF1LL_OFFSET 7u
#define MCAN_ILS_HPML_MASK 0x00000100u
#define MCAN_ILS_HPML_OFFSET 8u
#define MCAN_ILS_TCL_MASK 0x00000200u
#define MCAN_ILS_TCL_OFFSET 9u
#define MCAN_ILS_TCFL_MASK 0x00000400u
#define MCAN_ILS_TCFL_OFFSET 10u
#define MCAN_ILS_TFEL_MASK 0x00000800u
#define MCAN_ILS_TFEL_OFFSET 11u
#define MCAN_ILS_TEFNL_MASK 0x00001000u
#define MCAN_ILS_TEFNL_OFFSET 12u
#define MCAN_ILS_TEFWL_MASK 0x00002000u
#define MCAN_ILS_TEFWL_OFFSET 13u
#define MCAN_ILS_TEFFL_MASK 0x00004000u
#define MCAN_ILS_TEFFL_OFFSET 14u
#define MCAN_ILS_TEFLL_MASK 0x00008000u
#define MCAN_ILS_TEFLL_OFFSET 15u
#define MCAN_ILS_TSWL_MASK 0x00010000u
#define MCAN_ILS_TSWL_OFFSET 16u
#define MCAN_ILS_MRAFL_MASK 0x00020000u
#define MCAN_ILS_MRAFL_OFFSET 17u
#define MCAN_ILS_TOOL_MASK 0x00040000u
#define MCAN_ILS_TOOL_OFFSET 18u
#define MCAN_ILS_DRXL_MASK 0x00080000u
#define MCAN_ILS_DRXL_OFFSET 19u
#define MCAN_ILS_ELOL_MASK 0x00400000u
#define MCAN_ILS_ELOL_OFFSET 22u
#define MCAN_ILS_EPL_MASK 0x00800000u
#define MCAN_ILS_EPL_OFFSET 23u
#define MCAN_ILS_EWL_MASK 0x01000000u
#define MCAN_ILS_EWL_OFFSET 24u
#define MCAN_ILS_BOL_MASK 0x02000000u
#define MCAN_ILS_BOL_OFFSET 25u
#define MCAN_ILS_WDIL_MASK 0x04000000u
#define MCAN_ILS_WDIL_OFFSET 26u
#define MCAN_ILS_PEAL_MASK 0x08000000u
#define MCAN_ILS_PEAL_OFFSET 27u
#define MCAN_ILS_PEDL_MASK 0x10000000u
#define MCAN_ILS_PEDL_OFFSET 28u
#define MCAN_ILS_ARAL_MASK 0x20000000u
#define MCAN_ILS_ARAL_OFFSET 29u

#define MCAN_ILE_EINT0_MASK 0x00000001u
#define MCAN_ILE_EINT0_OFFSET 0u
#define MCAN_ILE_EINT1_MASK 0x00000002u
#define MCAN_ILE_EINT1_OFFSET 1u

#define MCAN_GFC_RRFE_MASK 0x00000001u
#define MCAN_GFC_RRFE_OFFSET 0u
#define MCAN_GFC_RRFS_MASK 0x00000002u
#define MCAN_GFC_RRFS_OFFSET 1u
#define MCAN_GFC_ANFE_MASK 0x0000000Cu
#define MCAN_GFC_ANFE_OFFSET 2u
#define MCAN_GFC_ANFS_MASK 0x00000030u
#define MCAN_GFC_ANFS_OFFSET 4u

#define MCAN_SIDFC_FLSSA_MASK 0x0000FFFCu
#define MCAN_SIDFC_FLSSA_OFFSET 2u
#define MCAN_SIDFC_LSS_MASK 0x00FF0000u
#define MCAN_SIDFC_LSS_OFFSET 16u

#define MCAN_XIDFC_FLESA_MASK 0x0000FFFCu
#define MCAN_XIDFC_FLESA_OFFSET 2u
#define MCAN_XIDFC_LSE_MASK 0x00FF0000u
#define MCAN_XIDFC_LSE_OFFSET 16u

#define MCAN_XIDAM_EIDM_MASK 0x1FFFFFFFu
#define MCAN_XIDAM_EIDM_OFFSET 0u

#define MCAN_HPMS_BIDX_MASK 0x0000003Fu
#define MCAN_HPMS_BIDX_OFFSET 0u
#define MCAN_HPMS_MSI_MASK 0x000000C0u
#define MCAN_HPMS_MSI_OFFSET 6u
#define MCAN_HPMS_FIDX_MASK 0x00007F00u
#define MCAN_HPMS_FIDX_OFFSET 8u
#define MCAN_HPMS_FLST_MASK 0x00008000u
#define MCAN_HPMS_FLST_OFFSET 15u

#define MCAN_NDAT1_ND0_MASK 0x00000001u
#define MCAN_NDAT1_ND0_OFFSET 0u
#define MCAN_NDAT1_ND1_MASK 0x00000002u
#define MCAN_NDAT1_ND1_OFFSET 1u
#define MCAN_NDAT1_ND2_MASK 0x00000004u
#define MCAN_NDAT1_ND2_OFFSET 2u
#define MCAN_NDAT1_ND3_MASK 0x00000008u
#define MCAN_NDAT1_ND3_OFFSET 3u
#define MCAN_NDAT1_ND4_MASK 0x00000010u
#define MCAN_NDAT1_ND4_OFFSET 4u
#define MCAN_NDAT1_ND5_MASK 0x00000020u
#define MCAN_NDAT1_ND5_OFFSET 5u
#define MCAN_NDAT1_ND6_MASK 0x00000040u
#define MCAN_NDAT1_ND6_OFFSET 6u
#define MCAN_NDAT1_ND7_MASK 0x00000080u
#define MCAN_NDAT1_ND7_OFFSET 7u
#define MCAN_NDAT1_ND8_MASK 0x00000100u
#define MCAN_NDAT1_ND8_OFFSET 8u
#define MCAN_NDAT1_ND9_MASK 0x00000200u
#define MCAN_NDAT1_ND9_OFFSET 9u
#define MCAN_NDAT1_ND10_MASK 0x00000400u
#define MCAN_NDAT1_ND10_OFFSET 10u
#define MCAN_NDAT1_ND11_MASK 0x00000800u
#define MCAN_NDAT1_ND11_OFFSET 11u
#define MCAN_NDAT1_ND12_MASK 0x00001000u
#define MCAN_NDAT1_ND12_OFFSET 12u
#define MCAN_NDAT1_ND13_MASK 0x00002000u
#define MCAN_NDAT1_ND13_OFFSET 13u
#define MCAN_NDAT1_ND14_MASK 0x00004000u
#define MCAN_NDAT1_ND14_OFFSET 14u
#define MCAN_NDAT1_ND15_MASK 0x00008000u
#define MCAN_NDAT1_ND15_OFFSET 15u
#define MCAN_NDAT1_ND16_MASK 0x00010000u
#define MCAN_NDAT1_ND16_OFFSET 16u
#define MCAN_NDAT1_ND17_MASK 0x00020000u
#define MCAN_NDAT1_ND17_OFFSET 17u
#define MCAN_NDAT1_ND18_MASK 0x00040000u
#define MCAN_NDAT1_ND18_OFFSET 18u
#define MCAN_NDAT1_ND19_MASK 0x00080000u
#define MCAN_NDAT1_ND19_OFFSET 19u
#define MCAN_NDAT1_ND20_MASK 0x00100000u
#define MCAN_NDAT1_ND20_OFFSET 20u
#define MCAN_NDAT1_ND21_MASK 0x00200000u
#define MCAN_NDAT1_ND21_OFFSET 21u
#define MCAN_NDAT1_ND22_MASK 0x00400000u
#define MCAN_NDAT1_ND22_OFFSET 22u
#define MCAN_NDAT1_ND23_MASK 0x00800000u
#define MCAN_NDAT1_ND23_OFFSET 23u
#define MCAN_NDAT1_ND24_MASK 0x01000000u
#define MCAN_NDAT1_ND24_OFFSET 24u
#define MCAN_NDAT1_ND25_MASK 0x02000000u
#define MCAN_NDAT1_ND25_OFFSET 25u
#define MCAN_NDAT1_ND26_MASK 0x04000000u
#define MCAN_NDAT1_ND26_OFFSET 26u
#define MCAN_NDAT1_ND27_MASK 0x08000000u
#define MCAN_NDAT1_ND27_OFFSET 27u
#define MCAN_NDAT1_ND28_MASK 0x10000000u
#define MCAN_NDAT1_ND28_OFFSET 28u
#define MCAN_NDAT1_ND29_MASK 0x20000000u
#define MCAN_NDAT1_ND29_OFFSET 29u
#define MCAN_NDAT1_ND30_MASK 0x40000000u
#define MCAN_NDAT1_ND30_OFFSET 30u
#define MCAN_NDAT1_ND31_MASK 0x80000000u
#define MCAN_NDAT1_ND31_OFFSET 31u

#define MCAN_NDAT2_ND32_MASK 0x00000001u
#define MCAN_NDAT2_ND32_OFFSET 0u
#define MCAN_NDAT2_ND33_MASK 0x00000002u
#define MCAN_NDAT2_ND33_OFFSET 1u
#define MCAN_NDAT2_ND34_MASK 0x00000004u
#define MCAN_NDAT2_ND34_OFFSET 2u
#define MCAN_NDAT2_ND35_MASK 0x00000008u
#define MCAN_NDAT2_ND35_OFFSET 3u
#define MCAN_NDAT2_ND36_MASK 0x00000010u
#define MCAN_NDAT2_ND36_OFFSET 4u
#define MCAN_NDAT2_ND37_MASK 0x00000020u
#define MCAN_NDAT2_ND37_OFFSET 5u
#define MCAN_NDAT2_ND38_MASK 0x00000040u
#define MCAN_NDAT2_ND38_OFFSET 6u
#define MCAN_NDAT2_ND39_MASK 0x00000080u
#define MCAN_NDAT2_ND39_OFFSET 7u
#define MCAN_NDAT2_ND40_MASK 0x00000100u
#define MCAN_NDAT2_ND40_OFFSET 8u
#define MCAN_NDAT2_ND41_MASK 0x00000200u
#define MCAN_NDAT2_ND41_OFFSET 9u
#define MCAN_NDAT2_ND42_MASK 0x00000400u
#define MCAN_NDAT2_ND42_OFFSET 10u
#define MCAN_NDAT2_ND43_MASK 0x00000800u
#define MCAN_NDAT2_ND43_OFFSET 11u
#define MCAN_NDAT2_ND44_MASK 0x00001000u
#define MCAN_NDAT2_ND44_OFFSET 12u
#define MCAN_NDAT2_ND45_MASK 0x00002000u
#define MCAN_NDAT2_ND45_OFFSET 13u
#define MCAN_NDAT2_ND46_MASK 0x00004000u
#define MCAN_NDAT2_ND46_OFFSET 14u
#define MCAN_NDAT2_ND47_MASK 0x00008000u
#define MCAN_NDAT2_ND47_OFFSET 15u
#define MCAN_NDAT2_ND48_MASK 0x00010000u
#define MCAN_NDAT2_ND48_OFFSET 16u
#define MCAN_NDAT2_ND49_MASK 0x00020000u
#define MCAN_NDAT2_ND49_OFFSET 17u
#define MCAN_NDAT2_ND50_MASK 0x00040000u
#define MCAN_NDAT2_ND50_OFFSET 18u
#define MCAN_NDAT2_ND51_MASK 0x00080000u
#define MCAN_NDAT2_ND51_OFFSET 19u
#define MCAN_NDAT2_ND52_MASK 0x00100000u
#define MCAN_NDAT2_ND52_OFFSET 20u
#define MCAN_NDAT2_ND53_MASK 0x00200000u
#define MCAN_NDAT2_ND53_OFFSET 21u
#define MCAN_NDAT2_ND54_MASK 0x00400000u
#define MCAN_NDAT2_ND54_OFFSET 22u
#define MCAN_NDAT2_ND55_MASK 0x00800000u
#define MCAN_NDAT2_ND55_OFFSET 23u
#define MCAN_NDAT2_ND56_MASK 0x01000000u
#define MCAN_NDAT2_ND56_OFFSET 24u
#define MCAN_NDAT2_ND57_MASK 0x02000000u
#define MCAN_NDAT2_ND57_OFFSET 25u
#define MCAN_NDAT2_ND58_MASK 0x04000000u
#define MCAN_NDAT2_ND58_OFFSET 26u
#define MCAN_NDAT2_ND59_MASK 0x08000000u
#define MCAN_NDAT2_ND59_OFFSET 27u
#define MCAN_NDAT2_ND60_MASK 0x10000000u
#define MCAN_NDAT2_ND60_OFFSET 28u
#define MCAN_NDAT2_ND61_MASK 0x20000000u
#define MCAN_NDAT2_ND61_OFFSET 29u
#define MCAN_NDAT2_ND62_MASK 0x40000000u
#define MCAN_NDAT2_ND62_OFFSET 30u
#define MCAN_NDAT2_ND63_MASK 0x80000000u
#define MCAN_NDAT2_ND63_OFFSET 31u

#define MCAN_RXF0C_F0SA_MASK 0x0000FFFCu
#define MCAN_RXF0C_F0SA_OFFSET 2u
#define MCAN_RXF0C_F0S_MASK 0x007F0000u
#define MCAN_RXF0C_F0S_OFFSET 16u
#define MCAN_RXF0C_F0WM_MASK 0x7F000000u
#define MCAN_RXF0C_F0WM_OFFSET 24u
#define MCAN_RXF0C_F0OM_MASK 0x80000000u
#define MCAN_RXF0C_F0OM_OFFSET 31u

#define MCAN_RXF0S_F0FL_MASK 0x0000007Fu
#define MCAN_RXF0S_F0FL_OFFSET 0u
#define MCAN_RXF0S_F0GI_MASK 0x00003F00u
#define MCAN_RXF0S_F0GI_OFFSET 8u
#define MCAN_RXF0S_F0PI_MASK 0x003F0000u
#define MCAN_RXF0S_F0PI_OFFSET 16u
#define MCAN_RXF0S_F0F_MASK 0x01000000u
#define MCAN_RXF0S_F0F_OFFSET 24u
#define MCAN_RXF0S_RF0L_MASK 0x02000000u
#define MCAN_RXF0S_RF0L_OFFSET 25u

#define MCAN_RXF0A_F0AI_MASK 0x0000003Fu
#define MCAN_RXF0A_F0AI_OFFSET 0u

#define MCAN_RXBC_RBSA_MASK 0x0000FFFCu
#define MCAN_RXBC_RBSA_OFFSET 0u

#define MCAN_RXF1C_F1SA_MASK 0x0000FFFCu
#define MCAN_RXF1C_F1SA_OFFSET 2u
#define MCAN_RXF1C_F1S_MASK 0x007F0000u
#define MCAN_RXF1C_F1S_OFFSET 16u
#define MCAN_RXF1C_F1WM_MASK 0x7F000000u
#define MCAN_RXF1C_F1WM_OFFSET 24u
#define MCAN_RXF1C_F1OM_MASK 0x80000000u
#define MCAN_RXF1C_F1OM_OFFSET 31u

#define MCAN_RXF1S_F1FL_MASK 0x0000007Fu
#define MCAN_RXF1S_F1FL_OFFSET 0u
#define MCAN_RXF1S_F1GI_MASK 0x00003F00u
#define MCAN_RXF1S_F1GI_OFFSET 8u
#define MCAN_RXF1S_F1PI_MASK 0x003F0000u
#define MCAN_RXF1S_F1PI_OFFSET 16u
#define MCAN_RXF1S_F1F_MASK 0x01000000u
#define MCAN_RXF1S_F1F_OFFSET 24u
#define MCAN_RXF1S_RF1L_MASK 0x02000000u
#define MCAN_RXF1S_RF1L_OFFSET 25u
#define MCAN_RXF1S_DMS_MASK 0xC0000000u
#define MCAN_RXF1S_DMS_OFFSET 30u

#define MCAN_RXF1A_F1AI_MASK 0x0000003Fu
#define MCAN_RXF1A_F1AI_OFFSET 0u

#define MCAN_RXESC_F0DS_MASK 0x00000007u
#define MCAN_RXESC_F0DS_OFFSET 0u
#define MCAN_RXESC_F1DS_MASK 0x00000070u
#define MCAN_RXESC_F1DS_OFFSET 4u
#define MCAN_RXESC_RBDS_MASK 0x00000700u
#define MCAN_RXESC_RBDS_OFFSET 8u

#define MCAN_TXBC_TBSA_MASK 0x0000FFFCu
#define MCAN_TXBC_TBSA_OFFSET 2u
#define MCAN_TXBC_NDTB_MASK 0x003F0000u
#define MCAN_TXBC_NDTB_OFFSET 16u
#define MCAN_TXBC_TFQS_MASK 0x3F000000u
#define MCAN_TXBC_TFQS_OFFSET 24u
#define MCAN_TXBC_TFQM_MASK 0x40000000u
#define MCAN_TXBC_TFQM_OFFSET 30u

#define MCAN_TXFQS_TFFL_MASK 0x0000003Fu
#define MCAN_TXFQS_TFFL_OFFSET 0u
#define MCAN_TXFQS_TFGI_MASK 0x00001F00u
#define MCAN_TXFQS_TFGI_OFFSET 8u
#define MCAN_TXFQS_TFQPI_MASK 0x001F0000u
#define MCAN_TXFQS_TFQPI_OFFSET 16u
#define MCAN_TXFQS_TFQF_MASK 0x00200000u
#define MCAN_TXFQS_TFQF_OFFSET 21u

#define MCAN_TXESC_TBDS_MASK 0x00000007u
#define MCAN_TXESC_TBDS_OFFSET 0u

#define MCAN_TXBRP_TRP0_MASK 0x00000001u
#define MCAN_TXBRP_TRP0_OFFSET 0u
#define MCAN_TXBRP_TRP1_MASK 0x00000002u
#define MCAN_TXBRP_TRP1_OFFSET 1u
#define MCAN_TXBRP_TRP2_MASK 0x00000004u
#define MCAN_TXBRP_TRP2_OFFSET 2u
#define MCAN_TXBRP_TRP3_MASK 0x00000008u
#define MCAN_TXBRP_TRP3_OFFSET 3u
#define MCAN_TXBRP_TRP4_MASK 0x00000010u
#define MCAN_TXBRP_TRP4_OFFSET 4u
#define MCAN_TXBRP_TRP5_MASK 0x00000020u
#define MCAN_TXBRP_TRP5_OFFSET 5u
#define MCAN_TXBRP_TRP6_MASK 0x00000040u
#define MCAN_TXBRP_TRP6_OFFSET 6u
#define MCAN_TXBRP_TRP7_MASK 0x00000080u
#define MCAN_TXBRP_TRP7_OFFSET 7u
#define MCAN_TXBRP_TRP8_MASK 0x00000100u
#define MCAN_TXBRP_TRP8_OFFSET 8u
#define MCAN_TXBRP_TRP9_MASK 0x00000200u
#define MCAN_TXBRP_TRP9_OFFSET 9u
#define MCAN_TXBRP_TRP10_MASK 0x00000400u
#define MCAN_TXBRP_TRP10_OFFSET 10u
#define MCAN_TXBRP_TRP11_MASK 0x00000800u
#define MCAN_TXBRP_TRP11_OFFSET 11u
#define MCAN_TXBRP_TRP12_MASK 0x00001000u
#define MCAN_TXBRP_TRP12_OFFSET 12u
#define MCAN_TXBRP_TRP13_MASK 0x00002000u
#define MCAN_TXBRP_TRP13_OFFSET 13u
#define MCAN_TXBRP_TRP14_MASK 0x00004000u
#define MCAN_TXBRP_TRP14_OFFSET 14u
#define MCAN_TXBRP_TRP15_MASK 0x00008000u
#define MCAN_TXBRP_TRP15_OFFSET 15u
#define MCAN_TXBRP_TRP16_MASK 0x00010000u
#define MCAN_TXBRP_TRP16_OFFSET 16u
#define MCAN_TXBRP_TRP17_MASK 0x00020000u
#define MCAN_TXBRP_TRP17_OFFSET 17u
#define MCAN_TXBRP_TRP18_MASK 0x00040000u
#define MCAN_TXBRP_TRP18_OFFSET 18u
#define MCAN_TXBRP_TRP19_MASK 0x00080000u
#define MCAN_TXBRP_TRP19_OFFSET 19u
#define MCAN_TXBRP_TRP20_MASK 0x00100000u
#define MCAN_TXBRP_TRP20_OFFSET 20u
#define MCAN_TXBRP_TRP21_MASK 0x00200000u
#define MCAN_TXBRP_TRP21_OFFSET 21u
#define MCAN_TXBRP_TRP22_MASK 0x00400000u
#define MCAN_TXBRP_TRP22_OFFSET 22u
#define MCAN_TXBRP_TRP23_MASK 0x00800000u
#define MCAN_TXBRP_TRP23_OFFSET 23u
#define MCAN_TXBRP_TRP24_MASK 0x01000000u
#define MCAN_TXBRP_TRP24_OFFSET 24u
#define MCAN_TXBRP_TRP25_MASK 0x02000000u
#define MCAN_TXBRP_TRP25_OFFSET 25u
#define MCAN_TXBRP_TRP26_MASK 0x04000000u
#define MCAN_TXBRP_TRP26_OFFSET 26u
#define MCAN_TXBRP_TRP27_MASK 0x08000000u
#define MCAN_TXBRP_TRP27_OFFSET 27u
#define MCAN_TXBRP_TRP28_MASK 0x10000000u
#define MCAN_TXBRP_TRP28_OFFSET 28u
#define MCAN_TXBRP_TRP29_MASK 0x20000000u
#define MCAN_TXBRP_TRP29_OFFSET 29u
#define MCAN_TXBRP_TRP30_MASK 0x40000000u
#define MCAN_TXBRP_TRP30_OFFSET 30u
#define MCAN_TXBRP_TRP31_MASK 0x80000000u
#define MCAN_TXBRP_TRP31_OFFSET 31u

#define MCAN_TXBAR_AR0_MASK 0x00000001u
#define MCAN_TXBAR_AR0_OFFSET 0u
#define MCAN_TXBAR_AR1_MASK 0x00000002u
#define MCAN_TXBAR_AR1_OFFSET 1u
#define MCAN_TXBAR_AR2_MASK 0x00000004u
#define MCAN_TXBAR_AR2_OFFSET 2u
#define MCAN_TXBAR_AR3_MASK 0x00000008u
#define MCAN_TXBAR_AR3_OFFSET 3u
#define MCAN_TXBAR_AR4_MASK 0x00000010u
#define MCAN_TXBAR_AR4_OFFSET 4u
#define MCAN_TXBAR_AR5_MASK 0x00000020u
#define MCAN_TXBAR_AR5_OFFSET 5u
#define MCAN_TXBAR_AR6_MASK 0x00000040u
#define MCAN_TXBAR_AR6_OFFSET 6u
#define MCAN_TXBAR_AR7_MASK 0x00000080u
#define MCAN_TXBAR_AR7_OFFSET 7u
#define MCAN_TXBAR_AR8_MASK 0x00000100u
#define MCAN_TXBAR_AR8_OFFSET 8u
#define MCAN_TXBAR_AR9_MASK 0x00000200u
#define MCAN_TXBAR_AR9_OFFSET 9u
#define MCAN_TXBAR_AR10_MASK 0x00000400u
#define MCAN_TXBAR_AR10_OFFSET 10u
#define MCAN_TXBAR_AR11_MASK 0x00000800u
#define MCAN_TXBAR_AR11_OFFSET 11u
#define MCAN_TXBAR_AR12_MASK 0x00001000u
#define MCAN_TXBAR_AR12_OFFSET 12u
#define MCAN_TXBAR_AR13_MASK 0x00002000u
#define MCAN_TXBAR_AR13_OFFSET 13u
#define MCAN_TXBAR_AR14_MASK 0x00004000u
#define MCAN_TXBAR_AR14_OFFSET 14u
#define MCAN_TXBAR_AR15_MASK 0x00008000u
#define MCAN_TXBAR_AR15_OFFSET 15u
#define MCAN_TXBAR_AR16_MASK 0x00010000u
#define MCAN_TXBAR_AR16_OFFSET 16u
#define MCAN_TXBAR_AR17_MASK 0x00020000u
#define MCAN_TXBAR_AR17_OFFSET 17u
#define MCAN_TXBAR_AR18_MASK 0x00040000u
#define MCAN_TXBAR_AR18_OFFSET 18u
#define MCAN_TXBAR_AR19_MASK 0x00080000u
#define MCAN_TXBAR_AR19_OFFSET 19u
#define MCAN_TXBAR_AR20_MASK 0x00100000u
#define MCAN_TXBAR_AR20_OFFSET 20u
#define MCAN_TXBAR_AR21_MASK 0x00200000u
#define MCAN_TXBAR_AR21_OFFSET 21u
#define MCAN_TXBAR_AR22_MASK 0x00400000u
#define MCAN_TXBAR_AR22_OFFSET 22u
#define MCAN_TXBAR_AR23_MASK 0x00800000u
#define MCAN_TXBAR_AR23_OFFSET 23u
#define MCAN_TXBAR_AR24_MASK 0x01000000u
#define MCAN_TXBAR_AR24_OFFSET 24u
#define MCAN_TXBAR_AR25_MASK 0x02000000u
#define MCAN_TXBAR_AR25_OFFSET 25u
#define MCAN_TXBAR_AR26_MASK 0x04000000u
#define MCAN_TXBAR_AR26_OFFSET 26u
#define MCAN_TXBAR_AR27_MASK 0x08000000u
#define MCAN_TXBAR_AR27_OFFSET 27u
#define MCAN_TXBAR_AR28_MASK 0x10000000u
#define MCAN_TXBAR_AR28_OFFSET 28u
#define MCAN_TXBAR_AR29_MASK 0x20000000u
#define MCAN_TXBAR_AR29_OFFSET 29u
#define MCAN_TXBAR_AR30_MASK 0x40000000u
#define MCAN_TXBAR_AR30_OFFSET 30u
#define MCAN_TXBAR_AR31_MASK 0x80000000u
#define MCAN_TXBAR_AR31_OFFSET 31u

#define MCAN_TXBCR_CR0_MASK 0x00000001u
#define MCAN_TXBCR_CR0_OFFSET 0u
#define MCAN_TXBCR_CR1_MASK 0x00000002u
#define MCAN_TXBCR_CR1_OFFSET 1u
#define MCAN_TXBCR_CR2_MASK 0x00000004u
#define MCAN_TXBCR_CR2_OFFSET 2u
#define MCAN_TXBCR_CR3_MASK 0x00000008u
#define MCAN_TXBCR_CR3_OFFSET 3u
#define MCAN_TXBCR_CR4_MASK 0x00000010u
#define MCAN_TXBCR_CR4_OFFSET 4u
#define MCAN_TXBCR_CR5_MASK 0x00000020u
#define MCAN_TXBCR_CR5_OFFSET 5u
#define MCAN_TXBCR_CR6_MASK 0x00000040u
#define MCAN_TXBCR_CR6_OFFSET 6u
#define MCAN_TXBCR_CR7_MASK 0x00000080u
#define MCAN_TXBCR_CR7_OFFSET 7u
#define MCAN_TXBCR_CR8_MASK 0x00000100u
#define MCAN_TXBCR_CR8_OFFSET 8u
#define MCAN_TXBCR_CR9_MASK 0x00000200u
#define MCAN_TXBCR_CR9_OFFSET 9u
#define MCAN_TXBCR_CR10_MASK 0x00000400u
#define MCAN_TXBCR_CR10_OFFSET 10u
#define MCAN_TXBCR_CR11_MASK 0x00000800u
#define MCAN_TXBCR_CR11_OFFSET 11u
#define MCAN_TXBCR_CR12_MASK 0x00001000u
#define MCAN_TXBCR_CR12_OFFSET 12u
#define MCAN_TXBCR_CR13_MASK 0x00002000u
#define MCAN_TXBCR_CR13_OFFSET 13u
#define MCAN_TXBCR_CR14_MASK 0x00004000u
#define MCAN_TXBCR_CR14_OFFSET 14u
#define MCAN_TXBCR_CR15_MASK 0x00008000u
#define MCAN_TXBCR_CR15_OFFSET 15u
#define MCAN_TXBCR_CR16_MASK 0x00010000u
#define MCAN_TXBCR_CR16_OFFSET 16u
#define MCAN_TXBCR_CR17_MASK 0x00020000u
#define MCAN_TXBCR_CR17_OFFSET 17u
#define MCAN_TXBCR_CR18_MASK 0x00040000u
#define MCAN_TXBCR_CR18_OFFSET 18u
#define MCAN_TXBCR_CR19_MASK 0x00080000u
#define MCAN_TXBCR_CR19_OFFSET 19u
#define MCAN_TXBCR_CR20_MASK 0x00100000u
#define MCAN_TXBCR_CR20_OFFSET 20u
#define MCAN_TXBCR_CR21_MASK 0x00200000u
#define MCAN_TXBCR_CR21_OFFSET 21u
#define MCAN_TXBCR_CR22_MASK 0x00400000u
#define MCAN_TXBCR_CR22_OFFSET 22u
#define MCAN_TXBCR_CR23_MASK 0x00800000u
#define MCAN_TXBCR_CR23_OFFSET 23u
#define MCAN_TXBCR_CR24_MASK 0x01000000u
#define MCAN_TXBCR_CR24_OFFSET 24u
#define MCAN_TXBCR_CR25_MASK 0x02000000u
#define MCAN_TXBCR_CR25_OFFSET 25u
#define MCAN_TXBCR_CR26_MASK 0x04000000u
#define MCAN_TXBCR_CR26_OFFSET 26u
#define MCAN_TXBCR_CR27_MASK 0x08000000u
#define MCAN_TXBCR_CR27_OFFSET 27u
#define MCAN_TXBCR_CR28_MASK 0x10000000u
#define MCAN_TXBCR_CR28_OFFSET 28u
#define MCAN_TXBCR_CR29_MASK 0x20000000u
#define MCAN_TXBCR_CR29_OFFSET 29u
#define MCAN_TXBCR_CR30_MASK 0x40000000u
#define MCAN_TXBCR_CR30_OFFSET 30u
#define MCAN_TXBCR_CR31_MASK 0x80000000u
#define MCAN_TXBCR_CR31_OFFSET 31u

#define MCAN_TXBTO_TO0_MASK 0x00000001u
#define MCAN_TXBTO_TO0_OFFSET 0u
#define MCAN_TXBTO_TO1_MASK 0x00000002u
#define MCAN_TXBTO_TO1_OFFSET 1u
#define MCAN_TXBTO_TO2_MASK 0x00000004u
#define MCAN_TXBTO_TO2_OFFSET 2u
#define MCAN_TXBTO_TO3_MASK 0x00000008u
#define MCAN_TXBTO_TO3_OFFSET 3u
#define MCAN_TXBTO_TO4_MASK 0x00000010u
#define MCAN_TXBTO_TO4_OFFSET 4u
#define MCAN_TXBTO_TO5_MASK 0x00000020u
#define MCAN_TXBTO_TO5_OFFSET 5u
#define MCAN_TXBTO_TO6_MASK 0x00000040u
#define MCAN_TXBTO_TO6_OFFSET 6u
#define MCAN_TXBTO_TO7_MASK 0x00000080u
#define MCAN_TXBTO_TO7_OFFSET 7u
#define MCAN_TXBTO_TO8_MASK 0x00000100u
#define MCAN_TXBTO_TO8_OFFSET 8u
#define MCAN_TXBTO_TO9_MASK 0x00000200u
#define MCAN_TXBTO_TO9_OFFSET 9u
#define MCAN_TXBTO_TO10_MASK 0x00000400u
#define MCAN_TXBTO_TO10_OFFSET 10u
#define MCAN_TXBTO_TO11_MASK 0x00000800u
#define MCAN_TXBTO_TO11_OFFSET 11u
#define MCAN_TXBTO_TO12_MASK 0x00001000u
#define MCAN_TXBTO_TO12_OFFSET 12u
#define MCAN_TXBTO_TO13_MASK 0x00002000u
#define MCAN_TXBTO_TO13_OFFSET 13u
#define MCAN_TXBTO_TO14_MASK 0x00004000u
#define MCAN_TXBTO_TO14_OFFSET 14u
#define MCAN_TXBTO_TO15_MASK 0x00008000u
#define MCAN_TXBTO_TO15_OFFSET 15u
#define MCAN_TXBTO_TO16_MASK 0x00010000u
#define MCAN_TXBTO_TO16_OFFSET 16u
#define MCAN_TXBTO_TO17_MASK 0x00020000u
#define MCAN_TXBTO_TO17_OFFSET 17u
#define MCAN_TXBTO_TO18_MASK 0x00040000u
#define MCAN_TXBTO_TO18_OFFSET 18u
#define MCAN_TXBTO_TO19_MASK 0x00080000u
#define MCAN_TXBTO_TO19_OFFSET 19u
#define MCAN_TXBTO_TO20_MASK 0x00100000u
#define MCAN_TXBTO_TO20_OFFSET 20u
#define MCAN_TXBTO_TO21_MASK 0x00200000u
#define MCAN_TXBTO_TO21_OFFSET 21u
#define MCAN_TXBTO_TO22_MASK 0x00400000u
#define MCAN_TXBTO_TO22_OFFSET 22u
#define MCAN_TXBTO_TO23_MASK 0x00800000u
#define MCAN_TXBTO_TO23_OFFSET 23u
#define MCAN_TXBTO_TO24_MASK 0x01000000u
#define MCAN_TXBTO_TO24_OFFSET 24u
#define MCAN_TXBTO_TO25_MASK 0x02000000u
#define MCAN_TXBTO_TO25_OFFSET 25u
#define MCAN_TXBTO_TO26_MASK 0x04000000u
#define MCAN_TXBTO_TO26_OFFSET 26u
#define MCAN_TXBTO_TO27_MASK 0x08000000u
#define MCAN_TXBTO_TO27_OFFSET 27u
#define MCAN_TXBTO_TO28_MASK 0x10000000u
#define MCAN_TXBTO_TO28_OFFSET 28u
#define MCAN_TXBTO_TO29_MASK 0x20000000u
#define MCAN_TXBTO_TO29_OFFSET 29u
#define MCAN_TXBTO_TO30_MASK 0x40000000u
#define MCAN_TXBTO_TO30_OFFSET 30u
#define MCAN_TXBTO_TO31_MASK 0x80000000u
#define MCAN_TXBTO_TO31_OFFSET 31u

#define MCAN_TXBCF_CF0_MASK 0x00000001u
#define MCAN_TXBCF_CF0_OFFSET 0u
#define MCAN_TXBCF_CF1_MASK 0x00000002u
#define MCAN_TXBCF_CF1_OFFSET 1u
#define MCAN_TXBCF_CF2_MASK 0x00000004u
#define MCAN_TXBCF_CF2_OFFSET 2u
#define MCAN_TXBCF_CF3_MASK 0x00000008u
#define MCAN_TXBCF_CF3_OFFSET 3u
#define MCAN_TXBCF_CF4_MASK 0x00000010u
#define MCAN_TXBCF_CF4_OFFSET 4u
#define MCAN_TXBCF_CF5_MASK 0x00000020u
#define MCAN_TXBCF_CF5_OFFSET 5u
#define MCAN_TXBCF_CF6_MASK 0x00000040u
#define MCAN_TXBCF_CF6_OFFSET 6u
#define MCAN_TXBCF_CF7_MASK 0x00000080u
#define MCAN_TXBCF_CF7_OFFSET 7u
#define MCAN_TXBCF_CF8_MASK 0x00000100u
#define MCAN_TXBCF_CF8_OFFSET 8u
#define MCAN_TXBCF_CF9_MASK 0x00000200u
#define MCAN_TXBCF_CF9_OFFSET 9u
#define MCAN_TXBCF_CF10_MASK 0x00000400u
#define MCAN_TXBCF_CF10_OFFSET 10u
#define MCAN_TXBCF_CF11_MASK 0x00000800u
#define MCAN_TXBCF_CF11_OFFSET 11u
#define MCAN_TXBCF_CF12_MASK 0x00001000u
#define MCAN_TXBCF_CF12_OFFSET 12u
#define MCAN_TXBCF_CF13_MASK 0x00002000u
#define MCAN_TXBCF_CF13_OFFSET 13u
#define MCAN_TXBCF_CF14_MASK 0x00004000u
#define MCAN_TXBCF_CF14_OFFSET 14u
#define MCAN_TXBCF_CF15_MASK 0x00008000u
#define MCAN_TXBCF_CF15_OFFSET 15u
#define MCAN_TXBCF_CF16_MASK 0x00010000u
#define MCAN_TXBCF_CF16_OFFSET 16u
#define MCAN_TXBCF_CF17_MASK 0x00020000u
#define MCAN_TXBCF_CF17_OFFSET 17u
#define MCAN_TXBCF_CF18_MASK 0x00040000u
#define MCAN_TXBCF_CF18_OFFSET 18u
#define MCAN_TXBCF_CF19_MASK 0x00080000u
#define MCAN_TXBCF_CF19_OFFSET 19u
#define MCAN_TXBCF_CF20_MASK 0x00100000u
#define MCAN_TXBCF_CF20_OFFSET 20u
#define MCAN_TXBCF_CF21_MASK 0x00200000u
#define MCAN_TXBCF_CF21_OFFSET 21u
#define MCAN_TXBCF_CF22_MASK 0x00400000u
#define MCAN_TXBCF_CF22_OFFSET 22u
#define MCAN_TXBCF_CF23_MASK 0x00800000u
#define MCAN_TXBCF_CF23_OFFSET 23u
#define MCAN_TXBCF_CF24_MASK 0x01000000u
#define MCAN_TXBCF_CF24_OFFSET 24u
#define MCAN_TXBCF_CF25_MASK 0x02000000u
#define MCAN_TXBCF_CF25_OFFSET 25u
#define MCAN_TXBCF_CF26_MASK 0x04000000u
#define MCAN_TXBCF_CF26_OFFSET 26u
#define MCAN_TXBCF_CF27_MASK 0x08000000u
#define MCAN_TXBCF_CF27_OFFSET 27u
#define MCAN_TXBCF_CF28_MASK 0x10000000u
#define MCAN_TXBCF_CF28_OFFSET 28u
#define MCAN_TXBCF_CF29_MASK 0x20000000u
#define MCAN_TXBCF_CF29_OFFSET 29u
#define MCAN_TXBCF_CF30_MASK 0x40000000u
#define MCAN_TXBCF_CF30_OFFSET 30u
#define MCAN_TXBCF_CF31_MASK 0x80000000u
#define MCAN_TXBCF_CF31_OFFSET 31u

#define MCAN_TXBTIE_TIE0_MASK 0x00000001u
#define MCAN_TXBTIE_TIE0_OFFSET 0u
#define MCAN_TXBTIE_TIE1_MASK 0x00000002u
#define MCAN_TXBTIE_TIE1_OFFSET 1u
#define MCAN_TXBTIE_TIE2_MASK 0x00000004u
#define MCAN_TXBTIE_TIE2_OFFSET 2u
#define MCAN_TXBTIE_TIE3_MASK 0x00000008u
#define MCAN_TXBTIE_TIE3_OFFSET 3u
#define MCAN_TXBTIE_TIE4_MASK 0x00000010u
#define MCAN_TXBTIE_TIE4_OFFSET 4u
#define MCAN_TXBTIE_TIE5_MASK 0x00000020u
#define MCAN_TXBTIE_TIE5_OFFSET 5u
#define MCAN_TXBTIE_TIE6_MASK 0x00000040u
#define MCAN_TXBTIE_TIE6_OFFSET 6u
#define MCAN_TXBTIE_TIE7_MASK 0x00000080u
#define MCAN_TXBTIE_TIE7_OFFSET 7u
#define MCAN_TXBTIE_TIE8_MASK 0x00000100u
#define MCAN_TXBTIE_TIE8_OFFSET 8u
#define MCAN_TXBTIE_TIE9_MASK 0x00000200u
#define MCAN_TXBTIE_TIE9_OFFSET 9u
#define MCAN_TXBTIE_TIE10_MASK 0x00000400u
#define MCAN_TXBTIE_TIE10_OFFSET 10u
#define MCAN_TXBTIE_TIE11_MASK 0x00000800u
#define MCAN_TXBTIE_TIE11_OFFSET 11u
#define MCAN_TXBTIE_TIE12_MASK 0x00001000u
#define MCAN_TXBTIE_TIE12_OFFSET 12u
#define MCAN_TXBTIE_TIE13_MASK 0x00002000u
#define MCAN_TXBTIE_TIE13_OFFSET 13u
#define MCAN_TXBTIE_TIE14_MASK 0x00004000u
#define MCAN_TXBTIE_TIE14_OFFSET 14u
#define MCAN_TXBTIE_TIE15_MASK 0x00008000u
#define MCAN_TXBTIE_TIE15_OFFSET 15u
#define MCAN_TXBTIE_TIE16_MASK 0x00010000u
#define MCAN_TXBTIE_TIE16_OFFSET 16u
#define MCAN_TXBTIE_TIE17_MASK 0x00020000u
#define MCAN_TXBTIE_TIE17_OFFSET 17u
#define MCAN_TXBTIE_TIE18_MASK 0x00040000u
#define MCAN_TXBTIE_TIE18_OFFSET 18u
#define MCAN_TXBTIE_TIE19_MASK 0x00080000u
#define MCAN_TXBTIE_TIE19_OFFSET 19u
#define MCAN_TXBTIE_TIE20_MASK 0x00100000u
#define MCAN_TXBTIE_TIE20_OFFSET 20u
#define MCAN_TXBTIE_TIE21_MASK 0x00200000u
#define MCAN_TXBTIE_TIE21_OFFSET 21u
#define MCAN_TXBTIE_TIE22_MASK 0x00400000u
#define MCAN_TXBTIE_TIE22_OFFSET 22u
#define MCAN_TXBTIE_TIE23_MASK 0x00800000u
#define MCAN_TXBTIE_TIE23_OFFSET 23u
#define MCAN_TXBTIE_TIE24_MASK 0x01000000u
#define MCAN_TXBTIE_TIE24_OFFSET 24u
#define MCAN_TXBTIE_TIE25_MASK 0x02000000u
#define MCAN_TXBTIE_TIE25_OFFSET 25u
#define MCAN_TXBTIE_TIE26_MASK 0x04000000u
#define MCAN_TXBTIE_TIE26_OFFSET 26u
#define MCAN_TXBTIE_TIE27_MASK 0x08000000u
#define MCAN_TXBTIE_TIE27_OFFSET 27u
#define MCAN_TXBTIE_TIE28_MASK 0x10000000u
#define MCAN_TXBTIE_TIE28_OFFSET 28u
#define MCAN_TXBTIE_TIE29_MASK 0x20000000u
#define MCAN_TXBTIE_TIE29_OFFSET 29u
#define MCAN_TXBTIE_TIE30_MASK 0x40000000u
#define MCAN_TXBTIE_TIE30_OFFSET 30u
#define MCAN_TXBTIE_TIE31_MASK 0x80000000u
#define MCAN_TXBTIE_TIE31_OFFSET 31u

#define MCAN_TXBCIE_CFIE0_MASK 0x00000001u
#define MCAN_TXBCIE_CFIE0_OFFSET 0u
#define MCAN_TXBCIE_CFIE1_MASK 0x00000002u
#define MCAN_TXBCIE_CFIE1_OFFSET 1u
#define MCAN_TXBCIE_CFIE2_MASK 0x00000004u
#define MCAN_TXBCIE_CFIE2_OFFSET 2u
#define MCAN_TXBCIE_CFIE3_MASK 0x00000008u
#define MCAN_TXBCIE_CFIE3_OFFSET 3u
#define MCAN_TXBCIE_CFIE4_MASK 0x00000010u
#define MCAN_TXBCIE_CFIE4_OFFSET 4u
#define MCAN_TXBCIE_CFIE5_MASK 0x00000020u
#define MCAN_TXBCIE_CFIE5_OFFSET 5u
#define MCAN_TXBCIE_CFIE6_MASK 0x00000040u
#define MCAN_TXBCIE_CFIE6_OFFSET 6u
#define MCAN_TXBCIE_CFIE7_MASK 0x00000080u
#define MCAN_TXBCIE_CFIE7_OFFSET 7u
#define MCAN_TXBCIE_CFIE8_MASK 0x00000100u
#define MCAN_TXBCIE_CFIE8_OFFSET 8u
#define MCAN_TXBCIE_CFIE9_MASK 0x00000200u
#define MCAN_TXBCIE_CFIE9_OFFSET 9u
#define MCAN_TXBCIE_CFIE10_MASK 0x00000400u
#define MCAN_TXBCIE_CFIE10_OFFSET 10u
#define MCAN_TXBCIE_CFIE11_MASK 0x00000800u
#define MCAN_TXBCIE_CFIE11_OFFSET 11u
#define MCAN_TXBCIE_CFIE12_MASK 0x00001000u
#define MCAN_TXBCIE_CFIE12_OFFSET 12u
#define MCAN_TXBCIE_CFIE13_MASK 0x00002000u
#define MCAN_TXBCIE_CFIE13_OFFSET 13u
#define MCAN_TXBCIE_CFIE14_MASK 0x00004000u
#define MCAN_TXBCIE_CFIE14_OFFSET 14u
#define MCAN_TXBCIE_CFIE15_MASK 0x00008000u
#define MCAN_TXBCIE_CFIE15_OFFSET 15u
#define MCAN_TXBCIE_CFIE16_MASK 0x00010000u
#define MCAN_TXBCIE_CFIE16_OFFSET 16u
#define MCAN_TXBCIE_CFIE17_MASK 0x00020000u
#define MCAN_TXBCIE_CFIE17_OFFSET 17u
#define MCAN_TXBCIE_CFIE18_MASK 0x00040000u
#define MCAN_TXBCIE_CFIE18_OFFSET 18u
#define MCAN_TXBCIE_CFIE19_MASK 0x00080000u
#define MCAN_TXBCIE_CFIE19_OFFSET 19u
#define MCAN_TXBCIE_CFIE20_MASK 0x00100000u
#define MCAN_TXBCIE_CFIE20_OFFSET 20u
#define MCAN_TXBCIE_CFIE21_MASK 0x00200000u
#define MCAN_TXBCIE_CFIE21_OFFSET 21u
#define MCAN_TXBCIE_CFIE22_MASK 0x00400000u
#define MCAN_TXBCIE_CFIE22_OFFSET 22u
#define MCAN_TXBCIE_CFIE23_MASK 0x00800000u
#define MCAN_TXBCIE_CFIE23_OFFSET 23u
#define MCAN_TXBCIE_CFIE24_MASK 0x01000000u
#define MCAN_TXBCIE_CFIE24_OFFSET 24u
#define MCAN_TXBCIE_CFIE25_MASK 0x02000000u
#define MCAN_TXBCIE_CFIE25_OFFSET 25u
#define MCAN_TXBCIE_CFIE26_MASK 0x04000000u
#define MCAN_TXBCIE_CFIE26_OFFSET 26u
#define MCAN_TXBCIE_CFIE27_MASK 0x08000000u
#define MCAN_TXBCIE_CFIE27_OFFSET 27u
#define MCAN_TXBCIE_CFIE28_MASK 0x10000000u
#define MCAN_TXBCIE_CFIE28_OFFSET 28u
#define MCAN_TXBCIE_CFIE29_MASK 0x20000000u
#define MCAN_TXBCIE_CFIE29_OFFSET 29u
#define MCAN_TXBCIE_CFIE30_MASK 0x40000000u
#define MCAN_TXBCIE_CFIE30_OFFSET 30u
#define MCAN_TXBCIE_CFIE31_MASK 0x80000000u
#define MCAN_TXBCIE_CFIE31_OFFSET 31u

#define MCAN_TXEFC_EFSA_MASK 0x0000FFFCu
#define MCAN_TXEFC_EFSA_OFFSET 2u
#define MCAN_TXEFC_EFS_MASK 0x003F0000u
#define MCAN_TXEFC_EFS_OFFSET 16u
#define MCAN_TXEFC_EFWM_MASK 0x3F000000u
#define MCAN_TXEFC_EFWM_OFFSET 24u

#define MCAN_TXEFS_EFFL_MASK 0x0000003Fu
#define MCAN_TXEFS_EFFL_OFFSET 0u
#define MCAN_TXEFS_EFGI_MASK 0x00001F00u
#define MCAN_TXEFS_EFGI_OFFSET 8u
#define MCAN_TXEFS_EFPI_MASK 0x001F0000u
#define MCAN_TXEFS_EFPI_OFFSET 16u
#define MCAN_TXEFS_EFF_MASK 0x01000000u
#define MCAN_TXEFS_EFF_OFFSET 24u
#define MCAN_TXEFS_TEFL_MASK 0x02000000u
#define MCAN_TXEFS_TEFL_OFFSET 25u

#define MCAN_TXEFA_EFAI_MASK 0x0000001Fu
#define MCAN_TXEFA_EFAI_OFFSET 0u

#define MCAN_TXELEMENT_ESI_WORD 0u
#define MCAN_TXELEMENT_ESI_MASK 0x80000000u
#define MCAN_TXELEMENT_ESI_OFFSET 31u
#define MCAN_TXELEMENT_XTD_WORD 0u
#define MCAN_TXELEMENT_XTD_MASK 0x40000000u
#define MCAN_TXELEMENT_XTD_OFFSET 30u
#define MCAN_TXELEMENT_RTR_WORD 0u
#define MCAN_TXELEMENT_RTR_MASK 0x20000000u
#define MCAN_TXELEMENT_RTR_OFFSET 29u
#define MCAN_TXELEMENT_STDID_WORD 0u
#define MCAN_TXELEMENT_STDID_MASK 0x1FFC0000u
#define MCAN_TXELEMENT_STDID_OFFSET 18u
#define MCAN_TXELEMENT_EXTID_WORD 0u
#define MCAN_TXELEMENT_EXTID_MASK 0x1FFFFFFFu
#define MCAN_TXELEMENT_EXTID_OFFSET 0u
#define MCAN_TXELEMENT_MM_WORD 1u
#define MCAN_TXELEMENT_MM_MASK 0xFF000000u
#define MCAN_TXELEMENT_MM_OFFSET 24u
#define MCAN_TXELEMENT_EFC_WORD 1u
#define MCAN_TXELEMENT_EFC_MASK 0x00800000u
#define MCAN_TXELEMENT_EFC_OFFSET 23u
#define MCAN_TXELEMENT_FDF_WORD 1u
#define MCAN_TXELEMENT_FDF_MASK 0x00200000u
#define MCAN_TXELEMENT_FDF_OFFSET 21u
#define MCAN_TXELEMENT_BRS_WORD 1u
#define MCAN_TXELEMENT_BRS_MASK 0x00100000u
#define MCAN_TXELEMENT_BRS_OFFSET 20u
#define MCAN_TXELEMENT_DLC_WORD 1u
#define MCAN_TXELEMENT_DLC_MASK 0x000F0000u
#define MCAN_TXELEMENT_DLC_OFFSET 16u
#define MCAN_TXELEMENT_DATA_WORD 2u

#define MCAN_RXELEMENT_ESI_WORD 0u
#define MCAN_RXELEMENT_ESI_MASK 0x80000000u
#define MCAN_RXELEMENT_ESI_OFFSET 31u
#define MCAN_RXELEMENT_XTD_WORD 0u
#define MCAN_RXELEMENT_XTD_MASK 0x40000000u
#define MCAN_RXELEMENT_XTD_OFFSET 30u
#define MCAN_RXELEMENT_RTR_WORD 0u
#define MCAN_RXELEMENT_RTR_MASK 0x20000000u
#define MCAN_RXELEMENT_RTR_OFFSET 29u
#define MCAN_RXELEMENT_STDID_WORD 0u
#define MCAN_RXELEMENT_STDID_MASK 0x1FFC0000u
#define MCAN_RXELEMENT_STDID_OFFSET 18u
#define MCAN_RXELEMENT_EXTID_WORD 0u
#define MCAN_RXELEMENT_EXTID_MASK 0x1FFFFFFFu
#define MCAN_RXELEMENT_EXTID_OFFSET 0u
#define MCAN_RXELEMENT_ANMF_WORD 1u
#define MCAN_RXELEMENT_ANMF_MASK 0x80000000u
#define MCAN_RXELEMENT_ANMF_OFFSET 31u
#define MCAN_RXELEMENT_FIDX_WORD 1u
#define MCAN_RXELEMENT_FIDX_MASK 0x7F000000u
#define MCAN_RXELEMENT_FIDX_OFFSET 24u
#define MCAN_RXELEMENT_FDF_WORD 1u
#define MCAN_RXELEMENT_FDF_MASK 0x00200000u
#define MCAN_RXELEMENT_FDF_OFFSET 21u
#define MCAN_RXELEMENT_BRS_WORD 1u
#define MCAN_RXELEMENT_BRS_MASK 0x00100000u
#define MCAN_RXELEMENT_BRS_OFFSET 20u
#define MCAN_RXELEMENT_DLC_WORD 1u
#define MCAN_RXELEMENT_DLC_MASK 0x000F0000u
#define MCAN_RXELEMENT_DLC_OFFSET 16u
#define MCAN_RXELEMENT_RXTS_WORD 1u
#define MCAN_RXELEMENT_RXTS_MASK 0x0000FFFFu
#define MCAN_RXELEMENT_RXTS_OFFSET 0u
#define MCAN_RXELEMENT_DATA_WORD 2u

#define MCAN_TXEVENTELEMENT_ESI_WORD 0u
#define MCAN_TXEVENTELEMENT_ESI_MASK 0x80000000u
#define MCAN_TXEVENTELEMENT_ESI_OFFSET 31u
#define MCAN_TXEVENTELEMENT_XTD_WORD 0u
#define MCAN_TXEVENTELEMENT_XTD_MASK 0x40000000u
#define MCAN_TXEVENTELEMENT_XTD_OFFSET 30u
#define MCAN_TXEVENTELEMENT_RTR_WORD 0u
#define MCAN_TXEVENTELEMENT_RTR_MASK 0x20000000u
#define MCAN_TXEVENTELEMENT_RTR_OFFSET 29u
#define MCAN_TXEVENTELEMENT_STDID_WORD 0u
#define MCAN_TXEVENTELEMENT_STDID_MASK 0x1FFC0000u
#define MCAN_TXEVENTELEMENT_STDID_OFFSET 18u
#define MCAN_TXEVENTELEMENT_EXTID_WORD 0u
#define MCAN_TXEVENTELEMENT_EXTID_MASK 0x1FFFFFFFu
#define MCAN_TXEVENTELEMENT_EXTID_OFFSET 0u
#define MCAN_TXEVENTELEMENT_MM_WORD 1u
#define MCAN_TXEVENTELEMENT_MM_MASK 0xFF000000u
#define MCAN_TXEVENTELEMENT_MM_OFFSET 24u
#define MCAN_TXEVENTELEMENT_ET_WORD 1u
#define MCAN_TXEVENTELEMENT_ET_MASK 0x00C00000u
#define MCAN_TXEVENTELEMENT_ET_OFFSET 22u
#define MCAN_TXEVENTELEMENT_FDF_WORD 1u
#define MCAN_TXEVENTELEMENT_FDF_MASK 0x00200000u
#define MCAN_TXEVENTELEMENT_FDF_OFFSET 21u
#define MCAN_TXEVENTELEMENT_BRS_WORD 1u
#define MCAN_TXEVENTELEMENT_BRS_MASK 0x00100000u
#define MCAN_TXEVENTELEMENT_BRS_OFFSET 20u
#define MCAN_TXEVENTELEMENT_DLC_WORD 1u
#define MCAN_TXEVENTELEMENT_DLC_MASK 0x000F0000u
#define MCAN_TXEVENTELEMENT_DLC_OFFSET 16u
#define MCAN_TXEVENTELEMENT_TXTS_WORD 1u
#define MCAN_TXEVENTELEMENT_TXTS_MASK 0x0000FFFFu
#define MCAN_TXEVENTELEMENT_TXTS_OFFSET 0u
#define MCAN_TXEVENTELEMENT_SIZE 8u

#define MCAN_STDRXFILTERELEMENT_SFT_MASK 0xC0000000u
#define MCAN_STDRXFILTERELEMENT_SFT_OFFSET 30u
#define MCAN_STDRXFILTERELEMENT_SFEC_MASK 0x38000000u
#define MCAN_STDRXFILTERELEMENT_SFEC_OFFSET 27u
#define MCAN_STDRXFILTERELEMENT_SFID1_MASK 0x07FF0000u
#define MCAN_STDRXFILTERELEMENT_SFID1_OFFSET 16u
#define MCAN_STDRXFILTERELEMENT_SFID2_MASK 0x000007FFu
#define MCAN_STDRXFILTERELEMENT_SFID2_OFFSET 0u
#define MCAN_STDRXFILTERELEMENT_SIZE 4u

#define MCAN_EXTRXFILTERELEMENT_EFEC_WORD 0u
#define MCAN_EXTRXFILTERELEMENT_EFEC_MASK 0xE0000000u
#define MCAN_EXTRXFILTERELEMENT_EFEC_OFFSET 29u
#define MCAN_EXTRXFILTERELEMENT_EFID1_WORD 0u
#define MCAN_EXTRXFILTERELEMENT_EFID1_MASK 0x1FFFFFFFu
#define MCAN_EXTRXFILTERELEMENT_EFID1_OFFSET 0u
#define MCAN_EXTRXFILTERELEMENT_EFT_WORD 1u
#define MCAN_EXTRXFILTERELEMENT_EFT_MASK 0xC0000000u
#define MCAN_EXTRXFILTERELEMENT_EFT_OFFSET 30u
#define MCAN_EXTRXFILTERELEMENT_EFID2_WORD 1u
#define MCAN_EXTRXFILTERELEMENT_EFID2_MASK 0x1FFFFFFFu
#define MCAN_EXTRXFILTERELEMENT_EFID2_OFFSET 0u
#define MCAN_EXTRXFILTERELEMENT_SIZE 8u

#define MCAN_RXELEMENT_SIZE_INVALID 0xFFu
#define MCAN_TXELEMENT_SIZE_INVALID 0xFFu
#define MCAN_DLC_INVALID 0xF7u

#endif // N7S_BSP_MCAN_MCANREGISTERS_H
